<?php
#
# Copyright(C) 2004-2005 INL
# Written by Eric Leblond <regit@inl.fr>
#            Vincent Deffontaines <gryzor@inl.fr>
#	     Jean Gillaux <jean@inl.fr>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, version 2 of the License.
#
#  This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#

$lang='en';

$pages_list=array("index","nat","acls","protocols","subjects","ressources","applications","floatings");


$datadir="/var/lib/nuface";
$logdir="/var/log/nuface";
$lockdir="/var/lib/nuface";

$tmpdir="/tmp";

$rules_dir="/etc/nuface/dyn";
$nufw_rules_dir="/etc/nuface/dyn/nufw";
$std_rules_dir="/etc/nuface/dyn/standard";
$nufw_rules_file="fwd_rules";
$std_rules_file="nonufw_rules";
$nupyf_ldap_file="ldap_objects";
$nupyf_conf_file="nupyf.conf";


$network_desc_dir="/etc/nuface/desc";
$network_desc_file="desc.xml";
#$network_desc_file=array("desc.xml","desc2.xml");

$nupyf_command="/usr/sbin/nupyf";

$sudo_command="/usr/bin/sudo";

$network_script_dir="/etc/nuface";
$firewall_script="/etc/rc.d/init.d/nupyf";


$manage_input=true;
$manage_output=true;
$manage_nat=true;

if ($lang=='fr')
  $pages_display=array("action","nat","acls","protocoles","sujets","ressources","applications","lments de travail");
else
  $pages_display=array("action","nat","acls","protocols","subjects","resources","applications","floatings");

$logout_link=1;

#Whether to load the edenavbar for a full EdenWall integration with nuconf/nulog/etc.
#$edenwall_integration=1;

# wheter to use getent to retrieve groups information: name and gid
#$use_getent_groups=1;
# path to file (in /etc/group format) to use instead of system conf
# (use_getent_groups must be set to 1)
#$groups_file='/tmp/groups.txt';
# path to file representing local groups, typicaly /etc/groups
# use it if local groups must not be displayed in nufw elts groups lists
#$sys_groupfile = '/etc/group';

