/*
#
# Copyright(C) 2004-2006 INL
# Written by Eric Leblond <regit@inl.fr>
#            Vincent Deffontaines <gryzor@inl.fr>
#             Jean Gillaux <jean@inl.fr>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, version 2 of the License.
#
#  This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
*/
var temp, temp2, cookieArray, cookieArray2, cookieCount;

function initiate(){

  cookieCount=0;

  if(document.cookie){

    cookieArray=document.cookie.split(";");
    cookieArray2=new Array();

    for(i in cookieArray){
      cookieArray2[cookieArray[i].split("=")[0].replace(/ /g,"")]=cookieArray[i].split("=")[1].replace(/ /g,"");
    }

  }

  cookieArray=(document.cookie.indexOf("state=")>=0)?cookieArray2["state"].split(","):new Array();

  temp=document.getElementById("containerul");

  for(var o=0;o<temp.getElementsByTagName("li").length;o++){

    if(temp.getElementsByTagName("li")[o].getElementsByTagName("ul").length>0){

      temp2                             = document.createElement("span");
      temp2.className                   = "symbols";
      temp2.style.backgroundImage       = (cookieArray.length>0)?((cookieArray[cookieCount]=="true")?"url(minus.png)":"url(plus.png)"):"url(plus.png)";
      temp2.onclick=function(){
        showhide(this.parentNode);
        writeCookie();
      }

      temp.getElementsByTagName("li")[o].insertBefore(temp2,temp.getElementsByTagName("li")[o].firstChild)

      temp.getElementsByTagName("li")[o].getElementsByTagName("ul")[0].style.display = "none";

      if(cookieArray[cookieCount]=="true"){
        showhide(temp.getElementsByTagName("li")[o]);
      }

      cookieCount++;

    }
    else{

      temp2                             = document.createElement("span");
      temp2.className                   = "symbols";
      temp2.style.backgroundImage       = "url(page.png)";

      temp.getElementsByTagName("li")[o].insertBefore(temp2,temp.getElementsByTagName("li")[o].firstChild);

    }

  }

}



function showhide(el){

  el.getElementsByTagName("ul")[0].style.display=(el.getElementsByTagName("ul")[0].style.display=="block")?"none":"block";

  el.getElementsByTagName("span")[0].style.backgroundImage=(el.getElementsByTagName("ul")[0].style.display=="block")?"url(minus.png)":"url(plus.png)";

}



function writeCookie(){         // Runs through the menu and puts the "states" of each nested list into an array, the array is then joined together and assigned to a cookie.

  cookieArray=new Array()

  for(var q=0;q<temp.getElementsByTagName("li").length;q++){

    if(temp.getElementsByTagName("li")[q].childNodes.length>0){
      if(temp.getElementsByTagName("li")[q].childNodes[0].nodeName=="SPAN" && temp.getElementsByTagName("li")[q].getElementsByTagName("ul").length>0){

        cookieArray[cookieArray.length]=(temp.getElementsByTagName("li")[q].getElementsByTagName("ul")[0].style.display=="block");

      }
    }

  }

  document.cookie="state="+cookieArray.join(",")+";expires="+new Date(new Date().getTime() + 12*60*60*1000).toGMTString();

}

var blnOk=true;
/*
function Chargement() {
  if(document.body.style.backgroundColor!="") { blnOk=false; }
  if(document.body.style.color!="") { blnOk=false; }
  if(document.body.style.marginTop!="") { blnOk=false; }
  if(document.getElementById) {
    with(document.getElementById("texte").style) {
      if(position!="") { blnOk=false; }
      if(top!="") { blnOk=false; }
      if(left!="") { blnOk=false; }
      if(width!="") { blnOk=false; }
      if(height!="") { blnOk=false; }
      if(zIndex!="") { blnOk=false; }
      if(margin!="") { blnOk=false; }
      if(padding!="") { blnOk=false; }
      if(visibility!="") { blnOk=false; }
    }
  }
  else{
  blnOk=false;
  }
  if(blnOk) {
    with(document.body.style) {
      backgroundColor="#333";
      color="#FFF";
      marginTop="5.2em";
    }
      
    with(document.getElementById("access").style) {
      position="absolute";
      top="1em";
      left="1em";
      margin="0";
    }
      
    with(document.getElementById("texte").style) {
      margin="0";
      padding="1em";
      backgroundColor="#FFF";
      color="#333";
    }
    
    for(i=1;i<=5;i++) {
      with(document.getElementById("ssmenu"+i).style) {
        position="absolute";
        top="4.4em";
        left=(((i-1)*11)+1)+"em";
        width="12em";
        margin="0";
        padding="0";
        zIndex="3";
      }
    }
    
    with(document.getElementById("copy").style) {
      backgroundColor="#333";
      color="#FFF";
    }
    
    CacherMenus();
  }
}
*/

function MontrerMenu(strMenu,param) {
  if(blnOk) {
    CacherMenus(param);  
    document.getElementById(strMenu).style.visibility="visible";
  }
}

function CacherMenus(param) {
  if(blnOk) {
    for(i=1;i<=param;i++) {
      with(document.getElementById("ssmenu"+i).style) {
        visibility="hidden";
      }
    }
  }
}

function griser_mark() {
  with(document.form) {
//    if(vpn.options[vpn.options.selectedIndex].text=="1") mark.disabled=false;
    if(vpn.checked=="1") mark.disabled=false;
    else {
      mark.value='';
      mark.disabled=true;
    }
  }
} 

function valider_apply() {
  with(document.form) {
    if(vpn.checked=="1") {
//      if (mark.options[mark.options.selectedIndex].text=="")
      if (net.value=="")
        alert("You must set a Network address, since the object refers to a VPN");
      else if (mark.value=="")
        alert("You must set a Mark, since the object refers to a VPN");
    }
  }
}

function griser_type() {
  with(document.forms.type) {
    if(proto.options[proto.options.selectedIndex].text=="icmp") icmptype.disabled=false;
    else {
      icmptype.value='--';
      icmptype.disabled=true;
    }
    if((proto.options[proto.options.selectedIndex].text=="tcp") || (proto.options[proto.options.selectedIndex].text=="udp")) {
      sport.disabled=false;
      dport.disabled=false;
    }
    else {
      sport.value='';
      sport.disabled=true;
      dport.value='';
      dport.disabled=true;
    }
  }
} 

function griser_natproto() {
  with(document.forms.natproto) {
    if(proto.options[proto.options.selectedIndex].text=="icmp") 
      icmptype.disabled=false;
    else {
      icmptype.value='--';
      icmptype.disabled=true;
    }
    if((proto.options[proto.options.selectedIndex].text=="tcp") || (proto.options[proto.options.selectedIndex].text=="udp")) {
      sport.disabled=false;
      dport.disabled=false;
      nat_port.disabled=false;
    }
    else {
      sport.value='';
      sport.disabled=true;
      dport.value='';
      dport.disabled=true;
      nat_port.value='';
      nat_port.disabled=true;
    }
  }
} 
function numOrdA(a, b){ return (a-b); }
/* Verify order of liste identified by id */
function ask_list_change(ids,msg){
    //alert(ids);
    tch = new Array();
    global_change = false; //algomerate change on all ids
    /*
        for each id, get actual order, and compare it to sorted list
    */
    for (idnum in ids){
        id = ids[idnum];
        change = false;
        //alert('computing id: '+idnum+' '+id+'.');
        var test = document.getElementById(id);
        if (test){
            list = junkdrawer.serializeList(test);
            tab = list.split('|');
            tab_sort = list.split('|');
            //alert(tab)
            tab_sort.sort();
            for (i=0; i<tab.length; i++){
                tab[i] = parseInt(tab[i]);
                tab_sort[i] = parseInt(tab_sort[i]);
            }
            tab_sort.sort(numOrdA);
            //alert(tab + "\n" + tab_sort)
            change = false;
            for (i=0; i<tab.length; i++){
                if (tab_sort[i] != tab[i]){
                    change = true;
                    break;
                }
            }
            if (tab == 'NaN') { 
                change = false;
            }
            if(change == true){
                //alert('changed: '+id+'.');
                tch[id] = true;
            }else{
                tch[id] = false;
            }

        }
    }
    //verify if one list order has been changed
    //alert(tch);
    for (id in tch){
        ch = tch[id];
        if(ch == true){
           global_change=true; 
        }
    }
    if(global_change == true){
        res = confirm(msg);
        return res;
    }
    return true;
}

/* Reset order of dnd list objects modified by user */
function resetOrder(listID){
  var list = document.getElementById(listID)
    if (list == null) {return;}
  var items = ToolMan.junkdrawer()._itemsByID(list);
  //items.sort()
  for (i=0; i<items.length; i++){
    if (i in items){
      var item = items[i];
      s= i+' '+item.innerHTML;
      //alert(s)
      list.removeChild(item);
      list.insertBefore(item, null);
    }
  }
}


